extern fmov, 200 // 代入
extern fstr, 201 // 文字列変換
extern ffloor, 202 // 切り捨て
extern fceil, 203 // 切り上げ
extern fadd, 204 // 加算
extern fsub, 205 // 減算
extern fmul, 206 // 乗算
extern fdiv, 207 // 除算
extern fsin, 208 // 正弦
extern fcos, 209 // 余弦
extern ftan, 210 // 正接
extern fcmp, 211 // 比較
extern fsqrt, 212 // 平方根
extern fexp, 213 // 指数
extern flog, 214 // 自然対数
extern flog10, 215 // 常用対数

mstruct float {
	V1 rb 4
	V2 rb 4
	V3 rb 4
	STR rb 20
}
mstruct cmp {
	V1 rb 4
	V2 rb 4
	V3 rb 4
	V4 rb 4
	V5 rb 4
	EPS rb 4
}

main()
end

def main() {
	var i

	// 代入
	fmov(float.V1, mstrf("10"))
	fmov(float.V2, mstrf("3"))

	// 加算
	fadd(float.V3, float.V1, float.V2)
	fstr(float.STR, float.V3)
	mprint float.STR: print

	// 減算
	fsub(float.V3, float.V1, float.V2)
	fstr(float.STR, float.V3)
	mprint float.STR: print

	// 乗算
	fmul(float.V3, float.V1, float.V2)
	fstr(float.STR, float.V3)
	mprint float.STR: print

	// 除算
	fdiv(float.V3, float.V1, float.V2)
	fstr(float.STR, float.V3)
	mprint float.STR: print

	// 誤差を考慮した比較
	fmov(cmp.V1, mstrf("0.998"))
	fmov(cmp.V2, mstrf("0.999"))
	fmov(cmp.V3, mstrf("1"))
	fmov(cmp.V4, mstrf("1.001"))
	fmov(cmp.V5, mstrf("1.002"))
	fmov(cmp.EPS, mstrf("0.001"))
	print fcmp(cmp.V3, cmp.V1, cmp.EPS)
	print fcmp(cmp.V3, cmp.V2, cmp.EPS)
	print fcmp(cmp.V3, cmp.V3, cmp.EPS)
	print fcmp(cmp.V3, cmp.V4, cmp.EPS)
	print fcmp(cmp.V3, cmp.V5, cmp.EPS)

	// 0.001を1000回足し込んでみる
	fmov(float.V1, mstrf("0"))
	fmov(float.V2, mstrf("0.001"))
	for i = 1 to 1000
		fadd(float.V1, float.V1, float.V2)
		fstr(float.STR, float.V1)
	next
	mprint float.STR: print
}
