extern fmov, 200 // 代入
extern fstr, 201 // 文字列変換
extern ffloor, 202 // 切り捨て
extern fceil, 203 // 切り上げ
extern fadd, 204 // 加算
extern fsub, 205 // 減算
extern fmul, 206 // 乗算
extern fdiv, 207 // 除算
extern fsin, 208 // 正弦
extern fcos, 209 // 余弦
extern ftan, 210 // 正接
extern fcmp, 211 // 比較
extern fsqrt, 212 // 平方根
extern fexp, 213 // 指数
extern flog, 214 // 自然対数
extern flog10, 215 // 常用対数

mstruct float {
	V1 rb 4
	V2 rb 4
	V3 rb 4
	STR rb 20
}
mstruct cmp {
	V1 rb 4
	V2 rb 4
	V3 rb 4
	V4 rb 4
	V5 rb 4
	EPS rb 4
}

main()
end

def main() {

	fmov(float.V1, mstrf("3.141593"))
	fstr(float.STR, float.V1)
	mprint float.STR: print

	// 切り捨て、切り上げ
	print ffloor(float.V1)
	print fceil(float.V1)

	// 正弦
	fsin(float.V2, float.V1)
	fstr(float.STR, float.V2)
	mprint float.STR: print

	// 余弦
	fcos(float.V2, float.V1)
	fstr(float.STR, float.V2)
	mprint float.STR: print

	// 正接
	ftan(float.V2, float.V1)
	fstr(float.STR, float.V2)
	mprint float.STR: print

	// 平方根
	fmov(float.V1, mstrf("2"))
	fsqrt(float.V2, float.V1)
	fstr(float.STR, float.V2)
	mprint float.STR: print

	// 指数
	fmov(float.V1, mstrf("2"))
	fexp(float.V2, float.V1)
	fstr(float.STR, float.V2)
	mprint float.STR: print

	// 自然対数
	mmove(float.V1, float.V2, 4) // 直前に計算したeの2乗の値をコピー
	flog(float.V2, float.V1)
	fstr(float.STR, float.V2)
	mprint float.STR: print

	// 常用対数
	fmov(float.V1, mstrf("10000"))
	flog10(float.V2, float.V1)
	fstr(float.STR, float.V2)
	mprint float.STR: print
}
